-- Test order_services_carousel
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(11);

set search_path to camper, public;

select has_function('camper', 'order_services_carousel', array['integer[]']);
select function_lang_is('camper', 'order_services_carousel', array['integer[]'], 'sql');
select function_returns('camper', 'order_services_carousel', array['integer[]'], 'void');
select isnt_definer('camper', 'order_services_carousel', array['integer[]']);
select volatility_is('camper', 'order_services_carousel', array['integer[]'], 'volatile');
select function_privs_are('camper', 'order_services_carousel', array ['integer[]'], 'guest', array[]::text[]);
select function_privs_are('camper', 'order_services_carousel', array ['integer[]'], 'employee', array[]::text[]);
select function_privs_are('camper', 'order_services_carousel', array ['integer[]'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'order_services_carousel', array ['integer[]'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate services_carousel_i18n cascade;
truncate services_carousel cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff00ff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffff00","a"};')
     , ('text/plain', 'hello, world!')
     , ('image/svg+xml', '<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (3, 1, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
     , (4, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffff00","a"};'))
     , (5, 1, 'text.txt', sha256('hello, world!'))
     , (6, 1, 'image.svg', sha256('<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>'))
;

insert into services_carousel (media_id, caption)
values (2, '1')
     , (3, '2')
     , (4, '3')
     , (5, '4')
     , (6, '5')
;

select lives_ok(
	$$ select order_services_carousel('{4,6,5,2,3}') $$,
	'Should be able to sort services slides using their ID'
);

select bag_eq(
	$$ select media_id, position from services_carousel $$,
	$$ values (4, 1)
	        , (6, 2)
	        , (5, 3)
	        , (2, 4)
	        , (3, 5)
	$$,
	'Should have sorted all services slides.'
);


select *
from finish();

rollback;
